program Zkrolly;
	uses
		SAT, sXprite, sZprite;

	var
		ignoresp, zp: SpritePtr;
		zWind: WindowPtr;
		r: Rect;

	const
		scrollSizeH = 200;
		scrollSizeV = 200;

	function IsOptionPressed: Boolean;
		var
			km: KeyMap;
	begin
		GetKeys(km);
		IsOptionPressed := km[58];
	end;

	function Zyncho: Boolean;
		var
			where, dest: Rect;
	begin
		where.topLeft := zp^.position;
		where.left := where.left - scrollSizeH div 2;
		where.top := where.top - scrollSizeV div 2;
		if where.left < 0 then
			where.left := 0;
		if where.top < 0 then
			where.top := 0;
		if where.left + scrollSizeH > gSAT.offSizeH then
			where.left := gSAT.offSizeH - scrollSizeH;
		if where.top + scrollSizeV > gSAT.offSizeV then
			where.top := gSAT.offSizeV - scrollSizeV;
		where.bottom := where.top + scrollSizeV;
		where.right := where.left + scrollSizeH;
		SetRect(dest, 0, 0, scrollSizeV, scrollSizeH);

		SATCopyBitsToScreen(gSAT.offScreen, where, dest, IsOptionPressed);
{Note that there's hardly any speed difference between fast and safe mode when copying areas this big!}

		Zyncho := true; {Tell SAT not to draw on-screen: we do that ourselves!}
	end;

	procedure SetupZwind;
		var
			zr: Rect;
			wrld: SysEnvRec;
	begin
{Since SAT hasn't been initialized yet, we can't use colorFlag but have to check environs ourselves.}
		if noErr <> SysEnvirons(1, wrld) then
			; {ignore errors}
		SetRect(zr, 20, 30, 20 + scrollSizeV, 30 + scrollSizeH);
		if wrld.hasColorQD then
			Zwind := NewCWindow(nil, zr, '', false, plainDBox, WindowPtr(-1), false, 0)
		else
			Zwind := NewWindow(nil, zr, '', false, plainDBox, WindowPtr(-1), false, 0);
	end;

begin
	SetupZwind;

	SetRect(r, 0, 0, 510, 340);
	CustomInitSAT(128, 129, r, zwind, nil, false, false, false, true, false);
	InitXprite;
	InitZprite;
	ShowWindow(gSAT.wind);
	SelectWindow(gSAT.wind);
	SATInstallSynch(@Zyncho);
	zp := NewSprite(0, 90, 70, @SetupZprite);
	ignoresp := NewSprite(0, 120, 100, @SetupXprite);
	ignoresp := NewSprite(0, 200, 160, @SetupXprite);
	repeat
		RunSAT(IsOptionPressed);
	until Button;

{WARNING! It seems like we mess up the current device somewhere. Probably a bug in SAT}
{(where the device setting isn't perfect yet). Let's set port and device to something nice}
{and safe!}
	SetPort(gSAT.wind);
	if colorFlag then
		SetGDevice(GetMainDevice);
{ Finally, make sure we dispose of the sound channel. }
	SATSoundShutup;
end.